﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Http;
using System.Web.Mvc;
using System.Web.Optimization;
using System.Web.Routing;
using System.Net.Http;
using System.Threading.Tasks;
using System.Threading;
using System.Web.Http.Filters;
using System.Web.Http.Controllers;
using System.Net;
using System.Collections.ObjectModel;
using System.Text.RegularExpressions;

namespace RESTWebAPI
{
  /*  public class EnableCorsAttribute : System.Web.Http.Filters.ActionFilterAttribute
    {
        const string Origin = "Origin";
        const string AccessControlAllowOrigin = "Access-Control-Allow-Origin";

        public override void OnActionExecuted(HttpActionExecutedContext actionExecutedContext)
        {
            if (actionExecutedContext.Request.Headers.Contains(Origin))
            {
                string originHeader = actionExecutedContext.Request.Headers.GetValues(Origin).FirstOrDefault();
                if (!string.IsNullOrEmpty(originHeader))
                {
                    actionExecutedContext.Response.Headers.Add(AccessControlAllowOrigin, originHeader);
                }
            }
        }
    }

    public class CorsPreflightActionSelector : ApiControllerActionSelector
    {
        const string Origin = "Origin";
        const string AccessControlRequestMethod = "Access-Control-Request-Method";

        public override HttpActionDescriptor SelectAction(HttpControllerContext controllerContext)
        {
            HttpRequestMessage originalRequest = controllerContext.Request;
            bool isCorsRequest = originalRequest.Headers.Contains(Origin);
            if (originalRequest.Method == HttpMethod.Options && isCorsRequest)
            {
                string accessControlRequestMethod = originalRequest.Headers.GetValues(AccessControlRequestMethod).FirstOrDefault();
                if (!string.IsNullOrEmpty(accessControlRequestMethod))
                {
                    HttpRequestMessage modifiedRequest = new HttpRequestMessage(
                        new HttpMethod(accessControlRequestMethod),
                        originalRequest.RequestUri);
                    controllerContext.Request = modifiedRequest;
                    HttpActionDescriptor actualDescriptor = base.SelectAction(controllerContext);
                    controllerContext.Request = originalRequest;
                    if (actualDescriptor != null)
                    {
                        if (actualDescriptor.GetFilters().OfType<EnableCorsAttribute>().Any())
                        {
                            return new PreflightActionDescriptor(actualDescriptor, accessControlRequestMethod);
                        }
                    }
                }
            }
            // cut cache preventing timestamp
            controllerContext.Request.RequestUri = new Uri(
                new Regex("[?,&]_=[0-9]*$").Replace(controllerContext.Request.RequestUri.AbsoluteUri, ""));
            return base.SelectAction(controllerContext);
        }
    }

    class PreflightActionDescriptor : HttpActionDescriptor
    {
        const string AccessControlRequestMethods = "Access-Control-Request-Methods";
        const string AccessControlRequestHeaders = "Access-Control-Request-Headers";
        const string AccessControlAllowMethods = "Access-Control-Allow-Methods";
        const string AccessControlAllowHeaders = "Access-Control-Allow-Headers";

        HttpActionDescriptor originalAction;
        string accessControlRequestMethod;

        public PreflightActionDescriptor(HttpActionDescriptor originalAction, string accessControlRequestMethod)
        {
            this.originalAction = originalAction;
            this.accessControlRequestMethod = accessControlRequestMethod;
        }

        public override string ActionName
        {
            get { return this.originalAction.ActionName; }
        }

        public override Task<object> ExecuteAsync(HttpControllerContext controllerContext, IDictionary<string, object> arguments)
        {
            var t = Task.Factory.StartNew<object>(() => Execute(controllerContext, arguments));
            return t;
        }

        public object Execute(HttpControllerContext controllerContext, IDictionary<string, object> arguments)
        {
            HttpResponseMessage response = new HttpResponseMessage(HttpStatusCode.OK);

            // No need to add the Origin; this will be added by the action filter

            response.Headers.Add(AccessControlAllowMethods, this.accessControlRequestMethod);

            string requestedHeaders = string.Join(
                ", ",
                controllerContext.Request.Headers.GetValues(AccessControlRequestHeaders));

            if (!string.IsNullOrEmpty(requestedHeaders))
            {
                response.Headers.Add(AccessControlAllowHeaders, requestedHeaders);
            }

            return response;
        }

        public override Collection<HttpParameterDescriptor> GetParameters()
        {
            return this.originalAction.GetParameters();
        }

        public override Type ReturnType
        {
            get { return typeof(HttpResponseMessage); }
        }

        public override Collection<System.Web.Http.Filters.FilterInfo> GetFilterPipeline()
        {
            return this.originalAction.GetFilterPipeline();
        }

        public override Collection<IFilter> GetFilters()
        {
            return this.originalAction.GetFilters();
        }

        public override Collection<T> GetCustomAttributes<T>()
        {
            return this.originalAction.GetCustomAttributes<T>();
        }
    }*/
}
